

               /*Ŀ
                                                                        
                  demo() = PROGRAM TO DEMONSTRATE THE USE OF THE        
                           TURBO C GRAPHICS FUNCTIONS WITH HERCULES     
                           GRAPHICS CARD.                               
                                                                        
                 */

               /*Ŀ
                                                                        
                                       INCLUDES                         
                                                                        
                 */

#include <math.h>

               /*Ŀ
                                                                        
                                 USER WRITTEN INCLUDES                  
                                                                        
                 */

#include "gdraws.h"

               /*Ŀ
                                                                        
                      GLOBAL VARIABLES USED BY GRAPHICS FUNCTIONS       
                                                                        
                 */

char adapt;
int color;
int background_color = 0;
int LINEWIDTH=1, OPERATOR=0, ANGLE, XCENTER, YCENTER;
int pt[12][2]={{-20,0},{0,0},{0,-120},{-200,-120},
	{-200,200},{90,150},{60,0},{200,0},{0,0}},x,y,z;
double xd,yd,ampl,aspect;
char ch;
int n,k;
int usa[600] = {-151,111,-146,
		107,-144, 96,-140, 96,-138,103,-139,111,-135,112,-111,
		103,-91, 96,-65, 92,-39, 89,-13, 85, 13, 85, 44, 82, 32,
		71, 30, 68, 35, 68, 41, 72, 41, 68, 44, 68, 54, 81, 57,
		81, 53, 74, 61, 72, 62, 70, 73, 75, 73, 72, 79, 71, 79,
		70, 75, 67, 69, 66, 63, 61, 61, 48, 61, 34, 63, 27, 65,
		27, 69, 38, 66, 48, 67, 55, 71, 60, 78, 66, 82, 66, 84,
		61, 84, 59, 87, 56, 86, 49, 89, 55, 93, 45, 87, 34, 93,
		31,114, 48,113, 53,127, 59,130, 68,152, 82,156,107,158,
		110,162,107,162,105,165,105,174, 89,160, 68,160, 61,165,
		55,167, 56,147, 59,158, 59,158, 55,160, 50,149, 34,149,
		20,147, 17,143, 24,140, 24,147, 15,144,  1,147, -2,149,
		-8,149,-13,145,-15,145,-19,149,-19,130,-39,119,-55,119,
		-61,123,-75,123,-75,130,-85,132,-89,134,-96,135,-103,134,
		-114,130,-115,123,-110,115,-96,110,-79,106,-72,104,-71,
		96, -77, 87,-85, 75,-71, 74,-74, 65,-74, 61,-78, 65,-85,
		52,-86, 45,-82, 28,-83, 19, -85, 13,-92,  5,-103,  5,
		-116,  2,-119, -1,-119, -7,-116, -9,-114,-11,-111,-12,
		-104,-13,-100,-21,-90,-26,-83,-33,-82,-42,-90,-57,-70,
		-65,-64,-77,-61,-78,-66,-98,-64,-124,-48,-137,-48,-139,
		-45,-139,-37,-146,-27,-159,-20,-161, -6,-165,  0,-165,
		4,-170, 20,-172, 27,-172, 41,-165, 55,-160, 78,-152, 96,
		-150,103,-151,111,-999};

unsigned long int PATTERN=0xFFFFFFFF;

unsigned long int style[8] = { 0xFFFFFFFF,0xC0C0C0C0,0xFF00FF00,0xFFF0FFF0,
                                0xF000F000,
                                0xFFFF0000,0xFFFFF0F0,0xFFF0F0F0};



               /*Ŀ
                                                                        
                                  FUNCTION DEFINITIONS                  
                                                                        
                 */

void building();
void wait(char title[]);
void drawArc (int xc, int yc, int b, int start_angle,int end_angle,
	     int color, float aspect);
float blend(int i, int n, float u);
void drawBezier(int segments,int color,...);
float bs_blend(int i, int n, float u);
void drawBspline(int segments, int color,...);
void drawBezier2(int segments, int color,...);

               /*Ŀ
                                                                        
                                      MAIN PROGRAM                      
                                                                        
                 */




main()
{
	int i, j, k, x, y, oldx, oldy, midpoint;
        double xd,yd,ampl;
	float aspect;
        char ch;
	cls(0);
	setMode(1);
                write_big_str(-119,131,"GRAPHICS",226);
                write_vid_str(-200,-6,"DEMONSTRATION",91);
                wait("");


                LINEWIDTH = 3;
                cls();
                drawRect(-309,210,310,-200,1);
                drawLine(-309,210,310,-200,1);
                drawLine(-309,-200,310,210,1);
                wait("Rectangle with Diagonals");

                LINEWIDTH = 5;
                ampl = 220;
                oldx = -315;
                oldy = 0;
		cls(0);
                for (i=0; i<=32; i++)
                {
                        y = ampl * sin(6.283 * ((double)i)/32);
                        x = 620 * (double)i/32 - 310;
                        drawLine (oldx, oldy, x, y, 1);
                        oldx = x;
                        oldy = y;
                }
                wait("Sine Wave");

	       	cls(0);
        	PATTERN = style[0];
	        drawRect(-310,230,-280,200,1);
        	PATTERN = style[1];
	        drawRect(-300,160,-240,75,1);
        	PATTERN = style[2];
	        drawRect(-280,35,-220,-100,1);
        	PATTERN = style[3];
	        LINEWIDTH = 1;
        	drawRect(-200,230,20,100,1);
	        PATTERN = style[4];
        	drawRect(-180,90,-70,-200,1);
	        PATTERN = style[5];
        	drawRect(40,75,60,200,1);
	        PATTERN = style[6];
        	drawRect(100,230,230,-175,1);
	        PATTERN = style[7];
        	drawRect(250,180,300,-90,1);
	        PATTERN = style[0];
		wait("Examples of Dashed Lines");

		LINEWIDTH = 1;
                fillRect(-304,210,30,-30,1);
                fillRect(-220,80,-20,-180,1);
                drawRect(-220,80,-20,-180,0);
                fillRect(-240,140,-70,30,1);
                drawRect(-240,140,-70,30,0);
                fillRect(-260,130,-150,-50,1);
                drawRect(-260,130,-150,-50,0);
                wait("Filled Rectangles");

                LINEWIDTH = 1;
                drawOval(-175,0,90,1,0.7);
                LINEWIDTH = 3;
                drawOval(65,0,90,1,1.0);
                LINEWIDTH = 5;
                drawOval(240,0,90,1,1.3);
                wait("Ovals and Circle");

                LINEWIDTH = 3;
                drawOval(-150,70,120,1,1.);
                drawOval(0,-70,120,1,1.);
                drawOval(150,70,120,1,1.);
                wait("Overlapping Circles");

                fillOval(-120,0,110,1,0.8);
                fillOval(180,0,110,1,1.);
                fillOval(220,50,20,0,1.);
                fillOval(140,50,20,0,1.);
                LINEWIDTH= 5;
                drawLine(150,-60,210,-60,0);
                drawLine(130,-53,150,-60,0);
                drawLine(230,-53,210,-60,0);
                drawLine(120,-40,130,-53,0);
                drawLine(240,-40,230,-53,0);
                wait("Filled Ovals");
                aspect = .50;
                for (i=0; i<3; i++)
                {
                LINEWIDTH = 3;
                        drawArc(0,0,120,0,450,1,aspect);
                        drawArc(0,0,120,450,900,1,aspect);
                        drawArc(0,0,120,900,1350,1,aspect);
                        drawArc(0,0,120,1350,1800,1,aspect);
                        drawArc(0,0,120,1800,2250,1,aspect);
                        drawArc(0,0,120,2250,2700,1,aspect);
                        drawArc(0,0,120,2700,3150,1,aspect);
                        drawArc(0,0,120,3150,3590,1,aspect);
                        wait("Oval Drawn By Combining Arcs");
                        aspect +=.5;
                }

                fillArc(0,0,140,480,1380,1,1.);
                fillArc(0,0,140,1380,1800,1,1.);
                fillArc(0,0,140,1800,2600,1,1.);
                fillArc(0,0,140,2600,3150,1,1.);
                fillArc(0,0,140,3150,3600,1,1.);
                fillArc(0,0,140,0,480,1,1.);
                wait("Pie Chart from Filled Arcs");


		LINEWIDTH = 1;
		PATTERN = style[1];
		for (n=0; n<7; n++)
			drawLine(pt[n][0],pt[n][1],pt[n+1][0],pt[n+1][1],1);
		PATTERN = style[0];
		drawBezier(160,1,-20,0,0,0,0,-120,-200,-120,-200,200,90,150,60,
			0,200,0,-999);
		wait("Bezier Curve");
		PATTERN = style[1];
		drawLine(-250,-25,-300,240,1);
		drawLine(-300,240,-80,210,1);
		drawLine(-80,210,-40,-25,1);
		drawLine(-40,-25,160,-25,1);
		drawLine(160,-25,300,-25,1);
		drawLine(300,-25,300,220,1);
		drawLine(300,220,40,240,1);
		drawLine(40,240,-80,-239,1);
		PATTERN = style[0];
		drawBezier(160,1,-250,-25,-300,240,-80,210,-40,-25,
			160,-25,-999);
		drawBezier(160,1,160,-25,300,-25,300,220,40,240,-80,-239,
			-999);
		wait("Two Bezier Curves");
		PATTERN = style[1];
                drawLine(-250,0,-220,200,1);
                drawLine(-220,200,-180,-200,1);
                drawLine(-180,-200,-140,60,1);
                drawLine(-140,60,-100,-30,1);
                drawLine(-100,-30,-70,-10,1);
		drawLine(-70,-10,-20,208,1);
		drawLine(-20,208,+60,-130,1);
		drawLine(+60,-130,100,125,1);
		drawLine(100,125,125,185,1);
		drawLine(125,185,140,160,1);
        	drawLine(140,160,170,-200,1);
        	drawLine(170,-200,190,-60,1);
        	drawLine(190,-60,220,20,1);
		PATTERN = style[0];
		drawBspline(160,1,-250,0,-220,200,-180,-200,-140,60,-100,-30,
			-70,-10,-20,208,60,-130,100,125,125,185,140,160,
			170,-200,190,-60,220,20,-999);
		wait("B-Spline Curve");

                x= -275;
                y= 200;
                for (k=0; k<37; k++)
                {
                        write_horz_char(x, y, k+33, 31);
                        x += 16;
                }
		x = -275;
		y = 180;
                for (k=37; k<74; k++)
                {
                        write_horz_char(x, y, k+33, 31);
                        x += 16;
                }
		x = -275;
   		y = 160;
                for (k=74; k<93; k++)
                {
                        write_horz_char(x, y, k+33, 31);
                        x += 16;
                }
		x= -319;
                y= -210;
                for (k=0; k<17; k++)
                {
                        write_vert_char(x, y, k+33, 47);
                        y += 20;
                }
		x = -303;
                y = -210;
                for (k=17; k<34; k++)
                {
                        write_vert_char(x, y, k+33, 47);
                        y += 20;
                }
		x = -287;
                y = -210;
                for (k=34; k<51; k++)
                {
                        write_vert_char(x, y, k+33, 47);
                        y += 20;
                }
		x = -271;
                y = -210;
                for (k=51; k<68; k++)
                {
                        write_vert_char(x, y, k+33, 47);
                        y += 20;
                }
		x = -255;
                y = -210;
                for (k=68; k<85; k++)
                {
                        write_vert_char(x, y, k+33, 47);
                        y += 20;
                }
		x = -239;
                y = -210;
                for (k=85; k<93; k++)
                {
                        write_vert_char(x, y, k+33, 47);
                        y += 20;
                }
                write_horz_str(-150,35, "HELLO WORLD!",62);
                write_vert_str(80,-200, "HOW ARE YOU TODAY?",109);
                wait("Alphanumerics");

                LINEWIDTH = 3;
                drawRoundRect(-300,210,300,-210,60,1);
                wait("Rounded Rectangle");

                fillRoundRect(-300,210,300,-210,60,1);
                wait("Filled Rounded Rectangle");

                building();
                wait("City Skyline at Night");

		drawPoly(1,-259, 90,-59, 90,-159,-90,-999);
		drawPoly(1,-259,-20,-159,160,-59,-20,-999);
		LINEWIDTH = 1;
		drawOval(161,34,107,1,1.0);
		fillPoly(1,60,66,262,66,104,-55,161,140,218,-55,-999);
		wait("Stars");

		fillPoly(1,-129,103,-69,172,-59,158,-64,144,-39,130,-34,151,
			-24,158,-19,116,1, 75,-9, 48, -49, 61,-19, -6,
			 -59,-34,-79,-6,-109,-48,-149,-6,-129,48,-149,61,
			-159,20,-179,61,-209,-34,-229,-6,-299,89,-249,103,
			-299,103,-299,130,-249,130,-269,172,-259,185,-999);
		fillPoly(1,120,0,168,-96,232,-96,232,-144,168,-144,72,-192,
			24,-160,24,-128,56,-128,40,-144,88,-128,88,-96,24,
			-64,120,32,-999);
		wait ("Irregular Polygons");

		PATTERN = style[0];
		fill2Poly(1,usa);
		wait("United States of America");

        	LINEWIDTH = 1;
	        cls(0);
	        XCENTER = -70;
        	YCENTER = 35;
	        for (ANGLE=0; ANGLE<180; ANGLE+=15)
	        	rotateRect(-220,100,80,-35,1);
	        wait("Rotated Rectangles");

        	cls(0);
        	XCENTER = 0;
	        YCENTER = 0;
        	for (ANGLE=0; ANGLE<360; ANGLE+=15)
        		rotatePoly(1,-120,-70,0,100,120,-70,-999);

	        wait("Rotated Triangles");
        	cls(0);
        	for (ANGLE=0; ANGLE<180; ANGLE+=15)
        		rotateOval(0,0,160,1,1.5);
        	wait("Rotated Ovals");
	setMode(0);
}

void wait(char title[])
{
        int tab;

	tab = (80 - strlen(title))/2;
        write_horz_str(9*tab-320,240,title,0);
        write_horz_str(-128,-220,"Press any key to continue demo...",0);
        getch();
        cls(0);
}


void building()
{
        int i,j;


        fillRect(-280,130,-220,-200,1);
        drawRect(-280,130,-220,-200,0);

        for(i=-275; i<=-235; i+=20)
        {
                for(j=125; j>=-170; j-=40)
                {
                        fillRect(i,j,i+10,j-25,0);
                }
        }


        fillRect(-140,160,-60,-230,1);
        drawRect(-140,160,-60,-230,0);

        for(i=-130; i<=-80; i+=20)
        {
                for(j=155; j>=-190; j-=42)
                {
                        fillRect(i,j,i+10,j-25,0);
                }
        }


        fillRect(-80,-7,60,-200,1);
        fillRect(-40,50,30,-7,1);
        drawRect(-80,-7,60,-200,0);
        drawRect(-40,50,30,-7,0);

        for(i=-75; i<=45; i+=20)
        {
                for(j=-12; j>=-185; j-=30)
                {
                        fillRect(i,j,i+10,j-10,0);
                }
        }

        fillRect(40,80,100,-230,1);
        drawRect(40,80,100,-230,0);

        for(i=45; i<=85; i+=20)
        {
                for(j=75; j>=-215; j-=30)
                {
                        fillRect(i,j,i+10,j-10,0);
                }
        }
	fillRect(-220,50,-120,-175,1);
	drawRect(-220,50,-120,-175,0);

        for(i=-215; i<=-135; i+=20)
        {
                for(j=45; j>=-160; j-=30)
                {
                        fillRect(i,j,i+10,j-10,0);
                }
        }
        fillRect(200,100,280,-175,1);
        drawRect(200,100,280,-175,0);

        for(i=205; i<=265; i+=20)
        {
                for(j=95; j>=-160; j-=35)
                {
                        fillRect(i,j,i+10,j-15,0);
                }
        }

        fillRect(180,190,240,-200,1);
        fillRect(200,75,220,190,1);
        drawRect(180,190,240,-200,0);
        drawRect(200,75,220,190,0);

        for(i=185; i<=225; i+=20)
        {
                for(j=185; j>=-185; j-=30)
                {
                        fillRect(i,j,i+10,j-10,0);
                }
        }
        fillRect(90,75,190,-230,1);
        fillRect(110,105,170,75,1);
        fillRect(130,130,150,105,1);
        drawRect(90,75,190,-230,0);
        drawRect(110,105,170,75,0);
        drawRect(130,130,150,105,0);


        for(i=95; i<=175; i+=20)
        {
                for(j=67; j>=-215; j-=30)
                {
                        fillRect(i,j,i+10,j-10,0);
                }
        }
        for(i=115; i<=155; i+=20)
        {
                for(j=100; j>=90; j-=30)
                {
                        fillRect(i,j,i+10,j-10,0);
                }
        }

        fillRect(-220,105,-180,50,1);
        drawRect(-220,105,-180,50,0);

        fillRect(-215,70,-205,55,0);
        fillRect(-195,70,-185,55,0);
        fillRect(-215,90,-205,75,0);
        fillRect(-195,90,-185,75,0);



fillOval(-20,195,20,1,1.);
fillOval(-30,195,20,0,1.);
}
