               /*Ŀ
                                                                        
                  drawBezier() = draws a Bezier curve                   
                                                                        
                 */

#include "gdraws.h"


void drawBezier(int segments, int color,...)
{
	#include <dos.h>
	#include <stdarg.h>
	#include <stdio.h>

	union REGS reg;

	float blend(int i, int n, float u);

        va_list coord;
        int xpoint[20],ypoint[20],i=0,j,oldx,oldy,px,py,last;
	float b,u,x,y;

	va_start(coord,color);
	while (((xpoint[i]=va_arg(coord,int)) >= -320) &&
		((ypoint[i]=va_arg(coord,int)) >= -320) && (i<=20))
		i++;
	va_end(coord);
	last = (i-1);
	for (i=0; i<=segments; i++)
	{
		u = (float)i/segments;
		x = 0;
		y = 0;
		for (j=0; j<=last; j++)
		{
			b = blend (j,last,u);
			x += xpoint[j]*b;
			y += ypoint[j]*b;
		}
		px = x;
		py = y;
		if (i>0)
			drawLine(oldx,oldy,px,py,color);
                oldx = x;
		oldy = y;
	}
}


float blend(int i, int n, float u)
{
	int c,j,k=1,g=1;
        float f;

	for (c=n; c>i; c--)
		k *= c;
        for (c=n-i; c>1; c--)
        	g *= c;
		f = (float)k/g;
        for (j=1; j<=i; j++)
        	f *= u;
        for (j=1; j<=n-i; j++)
        	f *= (1-u);
        return (f);
}

