               /*Ŀ
                                                                        
                    fillArc1() = subroutine for fillArc                 
                                                                        
                 */

#include <dos.h>
#include "gdraws.h"

union REGS reg;


void fillArc1 (int xc, int yc,int x, int y, int sector,
	     int arcTest[], int x_start_test, int x_end_test)
{
	#define dataOut(reg, value)   {outp(0x3CE, reg);\
					outp(0x3CF, value);}
	#define EGAaddress 0xA0000000L
	#define width 80L

	unsigned char mask, dummy;
	char far *color_address;

	int dx,dy,i,tx=0,ty=0,sdx,sdy,dxabs,dyabs;
	
        xc += 319;
        yc = 175 - ((93*yc) >> 7);
        x += 319;
        y = 175 - ((93*y) >> 7);
        x_start_test += 319;
        x_end_test += 319;
	switch (sector)
	{
		case 4:
  		case 5:
  		case 6:
  		case 7:
		if (arcTest[sector] == 2)
			break;
		if ((arcTest[sector] == 1) && (x>=x_start_test))
			break;
		if ((arcTest[sector] == 3) && (x<=x_end_test))
			break;
		if ((arcTest[sector] == 4) && (x>=x_start_test)
                   && (x<=x_end_test))
			break;
		return;
		case 0:
		case 1:
		case 2:
		case 3:
		if (arcTest[sector] == 2)
			break;
		if ((arcTest[sector] == 1) && (x<=x_start_test))
        		break;
        	if ((arcTest[sector] == 3) && (x>=x_end_test))
        		break;
        	if ((arcTest[sector] == 4) && (x>=x_end_test)
        		&& (x<=x_start_test))
			break;
		return;
	}
	if ((sector <= 1) || (sector >= 6))
		sdx = 1;
	else
		 sdx = -1;
	if (sector > 3)
		sdy = 1;
	else
		sdy = -1;
	dxabs = (x-xc)*sdx;
	dyabs = (y-yc)*sdy;
	if (dxabs >= dyabs)
	{
		for (i=0; i<= dxabs; i++)
		{
			ty+= dyabs;
			if (ty>dxabs)
			{
				ty -= dxabs;
				yc +=sdy;
			}
			color_address = (char far *) (EGAaddress +
					((long)yc * width + ((long)xc / 8L)));
			mask = 0x80 >> (xc % 8);
			dummy = *color_address;
			dataOut(8,mask);
			*color_address &= 0xFF;
			color_address = (char far *) (EGAaddress +
					((long)(yc+1) * width + ((long)xc / 8L)));
			mask = 0x80 >> (xc % 8);
			dummy = *color_address;
			dataOut(8,mask);
			*color_address &= 0xFF;
			xc+= sdx;
		}
	}
	else
	{
		for (i=0; i<= dyabs; i++)
		{
			tx+= dxabs;
			if (tx>dyabs)
			{
				tx -= dyabs;
				xc +=sdx;
			}
			color_address = (char far *) (EGAaddress +
					((long)yc * width + ((long)xc / 8L)));
			mask = 0x80 >> (xc % 8);
			dummy = *color_address;
			dataOut(8,mask);
			*color_address &= 0xFF;
			color_address = (char far *) (EGAaddress +
					((long)yc * width + ((long)(xc+1) / 8L)));
			mask = 0x80 >> ((xc+1) % 8);
			dummy = *color_address;
			dataOut(8,mask);
			*color_address &= 0xFF;
			yc+= sdy;
		}

	}
}

