               /*Ŀ
                                                                        
                   fillOval() = draws an oval centered at (x,y) with    
                                radius in y direction of 'b' with       
                                aspect ratio 'aspect' and fills it      
                                with color 'color'.                     
                                                                        
                 */

#include "gdraws.h"

extern int LINEWIDTH;

void fillOval(int x, int y, int b, int color, float aspect)
{
	int i;
        float a_temp;
	long a_square, b_square, two_a_square, two_b_square, four_a_square,
             four_b_square, d, a, row, col;
	
	x = ((x + 319)*18) >> 4;
	y = 174 - ((93*y) >> 7);		
	a_temp = b/aspect;
	a = (((int)(a_temp * 18)) >> 4) - LINEWIDTH/2;
	b = ((93*b) >> 7) - LINEWIDTH/2;	
	a_square = a*a;
	b_square = b*b;
	row = b;
	col = 0;
	two_a_square = a_square << 1;
	four_a_square = a_square << 2;
	four_b_square = b_square << 2;
	two_b_square = b_square << 1;
	d = two_a_square * ((row  -1)*(row )) + a_square +
	    two_b_square*(1-a_square);
	while (a_square*(row ) > b_square * (col))
	{
		for (i=y-row; i<=y+row; i++)
		{
			plot(x+col,i,color);
			plot(x-col,i,color);
		}
		if (d>= 0)
		{
			row--;
			d -= four_a_square*(row);
		}
		d += two_b_square*(3 + (col << 1));
		col++;
	}

	d = two_b_square * (col + 1)*col + two_a_square*(row *
                (row  -2) +1) + (1-two_a_square)*b_square;
	while ((row) + 1)
	{
		for (i=y-row; i<=y+row; i++)
		{
			plot(x+col,i,color);
			plot(x-col,i,color);
		}
		if (d<= 0)
		{
			col++;
			d += four_b_square*col;
		}
		row--;
		d += two_a_square * (3 - (row <<1));
	}
}
