               /*Ŀ
                                                                        
                    fillRect() = fills a rectangle whose top left and   
                                 bottom right corners are specified     
                                 with a specified color                 
                                                                        
                 */

#include "gdraws.h"

void fillRect(int x1, int y1, int x2, int y2, int color)
{
        #include <dos.h>

	int i,first,last,begin,end,start_mask,end_mask,mask,dummy,page,
		xs,xe;
	long int y1L, y2L,j;
	#define seq_out(index,val)  {outp(0x3C4,index);\
					 outp(0x3C5,val);}
	#define graph_out(index,val)  {outp(0x3CE,index);\
					 outp(0x3CF,val);}
	unsigned int offset;
	char far * mem_address;


	convert(x1,y1);
	convert(x2,y2);

	#ifdef CGA

	page = getPage();
	xs = x1 - (x1%4) +4;
	xe = x2 - (x1%4);

	for (i=y1; i<=y2; i++)
	{
		for (j=x1; j<xs; j++)
		{
			offset = 0x2000 * (i%2) + 4000 * page + 80 * (i/2)
				+ j/4;
			mask = 0xC0 >> ((j%4)*2);
			mem_address = 0xB8000000L +offset;
			*mem_address &= ~mask);
			mask = (color & 0x03) << (6 - (j%4) * 2);
			*mem_address |= mask;
		}
		for (j=xs; j<xe; j+=4)
		{
			offset = 0x2000 * (i%2) + 4000 * page + 80 * (i/2)
				+ j/4;
			mask = color & 0x03;
			mask += (mask << 2);
			mask += (mask << 4);
			mem_address = 0xB8000000L +offset;
			*mem_address = mask;

		}
		for (j=xe; j<=x2; j++)
		{
			offset = 0x2000 * (i%2) + 4000 * page + 80 * (i/2)
				+ j/4;
			mask = 0xC0 >> ((j%4)*2);
			mem_address = 0xB8000000L +offset;
			*mem_address &= ~mask);
			mask = (color & 0x03) << (6 - (j%4) * 2);
			*mem_address |= mask);
		}
	}

	#endif

	#ifndef CGA

	y1L = y1*80L;
	y2L = y2*80L;
        begin = x1/8;
	end = x2/8;
	first = x1 - begin*8;
	last = x2 - end*8 + 1;
	start_mask = 0xFF >> first;
	end_mask = 0xFF << (8-last);
	for (j=y1L; j<=y2L; j+=80)
	{
		offset = j + begin;
		mem_address = (char far *) 0xA0000000L + offset;
		graph_out(8,start_mask);
		seq_out(2,0x0F);
		dummy = *mem_address;
		*mem_address = 0;
		seq_out(2,color);
		*mem_address = start_mask;
		for (i=begin+1; i<end; i++)
		{
			offset = j + i;
			mem_address = (char far *) 0xA0000000L + offset;
			graph_out(8,0xFF);
			seq_out(2,0x0F);
			dummy = *mem_address;
			*mem_address = 0;
			seq_out(2,color);
			*mem_address = 0xFF;
		}
		offset = j + end;
		mem_address = (char far *) 0xA0000000L + offset;
		graph_out(8,end_mask);
		seq_out(2,0x0F);
		dummy = *mem_address;
		*mem_address = 0;
		seq_out(2,color);
		*mem_address = end_mask;
		seq_out(2,0x0F);
		graph_out(3,0);
		graph_out(8,0xFF);
	}
	#endif
}

