               /*Ŀ
                                                                        
                  fillRoundRect() = fills in a rectangle with rounded   
                           corners of radius 'b' with upper right       
                           corner 'x1,y1', lower left corner 'x2,y2',   
                           in specified color 'color'.                  
                                                                        
                 */


#include "gdraws.h"

void fillRoundRect(int x1, int y1, int x2, int y2, int b, int color)
{
	int a, xr, yr, col,i,j,row,xend,yend,flag;
	long a_square, b_square, two_a_square, two_b_square, four_a_square,
             four_b_square,d;

	yr = b;
        xr = b-2;
        xend = x2-xr;
        yend = y2+yr;
        b -= LINEWIDTH/2;
	a = b;
	b_square = b*b;
	a_square = a*a;
	fillRect(x1,y1-yr,x2,y2+yr,color);
	fillRect(x1+xr,y1,x2-xr,y2,color);
	row = b;
	col = 0;
	two_a_square = a_square << 1;
	four_a_square = a_square << 2;
	four_b_square = b_square << 2;
	two_b_square = b_square << 1;
	d = two_a_square * ((row  -1)*(row )) + a_square +
	    two_b_square*(1-a_square);
	while (a_square*(row ) > b_square * (col))
	{
		drawLine(xend,yend-row,col+xend,yend-row,color);
		drawLine(xend,y1-yr+row,col+xend,y1-yr+row, color);
		drawLine(x1+xr,yend-row,x1+xr-col,yend-row,color);
		drawLine(x1+xr,y1-yr+row,x1+xr-col,y1-yr+row,color);
		if (d>= 0)
		{
			row--;
			d -= four_a_square*(row);
		}
	d += two_b_square*(3 + (col << 1));
	col++;
	}
	d = two_b_square * (col + 1)*col + two_a_square*(row *
       	        (row  -2) +1) + (1-two_a_square)*b_square;
	while (row)
	{
		drawLine(xend,yend-row,col+xend,yend-row,color);
		drawLine(xend,y1-yr+row,col+xend,y1-yr+row, color);
		drawLine(x1+xr,yend-row,x1+xr-col,yend-row,color);
		drawLine(x1+xr,y1-yr+row,x1+xr-col,y1-yr+row,color);
		if (d<= 0)
		{
			col++;
			d += four_b_square*col;
		}
		row--;
		d += two_a_square * (3 - (row <<1));
	}       	
	b++;
	a++;
}
